[tox]
downloadcache = {toxworkdir}/cache/
envlist = py312,py311,py310,py39,py38,ruff,docs,pypy3

[testenv:py310]
passenv =
    GITHUB_ACTIONS
    GITHUB_TOKEN
deps = -rtox-requirements.txt
       -rrequirements.txt
commands =
       pytest --random-order-bucket=global -sv --cov-report= --cov-config .coveragerc --cov molotov molotov/tests
       - coverage combine
       - coverage report -m
       - coveralls


[testenv]
passenv =
    GITHUB_ACTIONS
    GITHUB_TOKEN
deps = -rtox-requirements.txt
       -rrequirements.txt
commands =
       pytest --random-order-bucket=global -sv molotov/tests

[testenv:pypy3]
passenv =
    GITHUB_ACTIONS
    GITHUB_TOKEN
deps = -rtox-pypy-requirements.txt
       -rrequirements.txt
commands =
       pytest --random-order-bucket=global -sv molotov/tests

[testenv:ruff]
commands =
  ruff check setup.py molotov
  ruf format setup.py molotov/*.py
deps =
    ruff

[testenv:docs]
deps =
    -rrequirements.txt
    sphinx
    -rdocs-requirements.txt
commands=
    sphinx-build -W -b html docs/source docs/build

[gh-actions]
python =
    3.8: py38
    3.9: py39
    3.10: py310, flake8, docs
    3.11: py311, flake8, docs
    3.12.0-beta.3: py312, flake8, docs
    pypy-3.8: pypy3
    pypy-3.9: pypy3
